# $Id$

use ExtUtils::MakeMaker;

WriteMakefile(
    NAME		=> 'User::utent',

    # On my SVR4-derived system I have to link against -lc in order to
    # resolve getutent() and others.  I presume this is because
    # libperl.so doesn't reference these functions.  I don't know what's
    # really going on, or if this will hurt other systems.  Let me know
    # if it does and I'll write a configure test.
    LIBS		=> '-lc',

    MAN3PODS		=> {
	'utent.pm'	=> '$(INST_MAN3DIR)/User::utent.$(MAN3EXT)',
	'utmp.pm'	=> '$(INST_MAN3DIR)/User::utent::utmp.$(MAN3EXT)',
	'utmpx.pm'	=> '$(INST_MAN3DIR)/User::utent::utmpx.$(MAN3EXT)',
    },
    PM			=> {
	'utent.pm'	=> '$(INST_LIBDIR)/utent.pm',
	'utmp.pm'	=> '$(INST_LIBDIR)/utent/utmp.pm',
	'utmpx.pm'	=> '$(INST_LIBDIR)/utent/utmpx.pm',
    },
    VERSION_FROM	=> 'pm',
    XS			=> { 'utent.xs' => 'utent.c' },
    XSPROTOARG		=> '-noprototypes',
    clean		=> {
    	FILES	=> 'config.cache config.h config.log config.myinfo '
		    . 'config.status stamp-h utent.pm utent.xs'
    },
    dist		=> {
    	COMPRESS	=> 'gzip --best',
    	DIST_CP		=> 'ln',
    	PREOP		=> '$(MAKE) configure stamp-h.in',
    	SUFFIX		=> 'gz',
    },
    test		=> { TESTS => 'test.t' },
);

sub MY::postamble {
    <<'EOF'
utent.o: config.h

utent.xs: xs gen-code config.myinfo
	$(PERL) gen-code xs > $@
utent.pm: pm gen-code config.myinfo
	$(PERL) gen-code pm > $@

# XXX rebuilding configure runs this, too.  Use a double colon rule?
config.h: stamp-h
stamp-h: config.h.in config.status
	./config.status
	echo timestamp > $@

# XXX Struct member defines are not getting into the generated config.h.in.
###config.h.in: stamp-h.in
###stamp-h.in: configure.in acconfig.h
###	autoheader
###	echo timestamp > $@

# I couldn't find a better way to do this, but there ought to be one.
real_cflags = $(INC) $(CCFLAGS) $(OPTIMIZE) $(PERLTYPE) $(LARGE) \
		$(SPLIT) $(DEFINE_VERSION) $(XS_DEFINE_VERSION)

config.status config.myinfo: configure
	CC="$(CC)" CFLAGS="$(real_cflags)" magic_makemaker_token=t \
	    ./configure $(CONFIGURE_FLAGS)

configure: configure.in aclocal.m4
	autoconf
EOF
}
